# -*- coding: utf-8 -*-

#3b) Sfruttando il codice contenuto nel modulo globalign.py, si costruisca 
# l'albero con tutti gli allineamenti ottimi per le stringhe nei file 
# myoglobin_homo_sapiens.fasta e myoglobin_danio_rerio.fasta - come matrice di 
# scoring si usi la PAM60 (nel modulo PAM.py), con gap penalty uniforme di -5.
# Si applichi poi al risultato la funzione sviluppata in 3a).
# Si individui la prima foglia dell'albero (quella corrispondente a seguire 
# sempre, partendo dalla radice, il primo figlio in lista). Da essa si risalga
# verso la radice e per ogni nodo si stampi sul file uso3.txt la 
# rappresentazione del campo info (ottenuta con il metodo str() ).


import globalign as ga 
import Bio.SeqIO as SeqIO
from PAM import pam60_dict
from soluzione3 import addFather

infile1  = "myoglobin_homo_sapiens.fasta"
infile2  = "myoglobin_danio_rerio.fasta"
outfile = "uso3.txt"

score_mat, score_gap = pam60_dict, -5

hs = str((SeqIO.read(infile1, format="fasta")).seq)
dr = str((SeqIO.read(infile2, format="fasta")).seq)

al =  ga.galign_tree(hs, dr, score_mat, score_gap)

addFather(al)

node = al
while node.clist:
    node = node.clist[0]
#now "node" corresponds to the first leaf
    
with open(outfile, "w") as f:
    while True:
        f.write(str(node.info)+"\n\n")
        if not node.father:
            break
        node = node.father

