# -*- coding: utf-8 -*-

#4b) Si considerino in PAM.py le matrici PAM120 e PAM90, nel formato di 
# dizionario di dizionari. Si stabilisca quale siano, tra tali matrici, le
# coppie di amminoacidi che presentano la maggiore variazione di punteggio
# (in valore assoluto). 
# Si scrivano tali coppie su righe consecutive del file uso4.txt; 
# ciascuna coppia dovrà comparire una sola volta, nel formato X Y, rispettando
# l'ordinamento alfabetico tra X e Y; le diverse coppie dovranno anch'esse
# essere ordinate alfabeticamente tra loro.


from soluzione4 import diff_dict
from PAM import pam120_dict, pam90_dict

outfile = "uso4.txt"

mdif = diff_dict(pam120_dict, pam90_dict)

globmax=0
couples=[]
for k1 in mdif:
    for k2 in mdif[k1]:
        variation = abs(mdif[k1][k2])
        couple = tuple(sorted([k1,k2]))
        if variation > globmax:
            couples =[couple]
            globmax = variation
        elif variation == globmax:
            couples.append(couple)

#duplicate removal + lexicogr. sorting
couples = sorted(list(set(couples)))

with open(outfile, "w") as f:
    for couple in couples:
        f.write(couple[0]+" "+couple[1]+"\n")

